from django.models.labels import labels
from django.views.decorators.auth import login_required
from django.core.extensions import get_object_or_404
from django.core.extensions import get_list_or_404
from django.core.exceptions import Http404
from django.utils.httpwrappers import HttpResponse, HttpResponseRedirect
from djangotest.core import formfields, render_to_response

def label(request, label_id):
    label = get_object_or_404(labels, pk=label_id)
    related = []
    for c in label._meta.get_all_related_many_to_many_objects():
        related_list = getattr(label, 'get_'+c.get_method_name_part()+'_list')()
        if related_list:
            related.append({'name':c.name, 'list':related_list})
    
    return render_to_response('labels/label', request, {'label':label, 'related':related})
    
def category(request, label_id, category):
    label = get_object_or_404(labels, pk=label_id)
    try :
        related_list = getattr(label, 'get_'+category+'_list')()
    except AttributeError:
        raise Http404

    return render_to_response('labels/category', request, {'label':label, 'related_list':related_list})
